
#ifndef VIEWER2D_H
#define VIEWER2D_H

#include "dirview.h"

#include <qgl.h>

#include <list>

class QListViewItem;
class Directory;
class FileItem;

class Viewer2D : public QGLWidget {
   Q_OBJECT
private:
   Directory * _dir;
   list< Directory * > _childDirs;
   list< FileItem * > _childFiles;
   int _widthInPixels, _heightInPixels;
   Rect2D _r;

   int _mouseX, _mouseY;
   Directory * _dirBeingDragged;
   FileItem * _fileBeingDragged;
public:
   Viewer2D( QWidget *parent, const char *name = 0 );
public slots:
   void fileSelected( QListViewItem * );
   void clear();
protected:
   void initializeGL();
   void resizeGL( int w, int h );
   void paintGL();
protected:
   void mousePressEvent( QMouseEvent * );
   void mouseReleaseEvent( QMouseEvent * );
   void mouseMoveEvent( QMouseEvent * );
   void mouseDoubleClickEvent( QMouseEvent * );
   void dragMoveEvent( QDragMoveEvent * );
};

#endif /* VIEWER2D_H */

